﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MM.Monitor.Client;

namespace MM.Monitor.Plugins
{
    public class MoreInfo : ClientPlugin
    {
        private const int PAGE_DETAILS = 1;

        public override Client.Version GetMinimumRequiredAgentVersion()
        {
            return new Client.Version(2,9,1);
        }
        public override string GetPluginName()
        {
            return "More Info";
        }
        public override string GetPluginDescription()
        {
            return "Allows for more information to be added to the computer details";
        }
        public override Groups GetAdditionalComputerDetails()
        {
            Groups result = new Groups();

            Group group = new Group("More Information");
            group.Items.Add(new PageItem(PAGE_DETAILS, "More Info", "Additional computer information"));
            result.Add(group);

            return result;
        }
        public override System.Windows.Forms.Form GetConfigurationForm()
        {
            return new MoreInfoConfiguration(this);
        }
        public override Groups GetPageDetails(int pageId)
        {
            if (pageId == PAGE_DETAILS)
            {
                Groups result = new Groups();
                Group group = new Group("More Information");

                int count = 0;
                bool hasDetails = int.TryParse(GetValueForKey("Count"), out count);

                if (hasDetails)
                {
                    for (int x = 1; x <= count; x++)
                    {
                        string title = this.GetValueForKey("Title" + x.ToString());
                        string subTitle = this.GetValueForKey("Subtitle" + x.ToString());

                        group.Items.Add(new SimpleItem(title == null ? "" : title, subTitle == null ? "" : subTitle));
                    }
                }
                else
                {
                    group.Items.Add(new SimpleItem("No data available", "Use PC Monitor Plugins section to configure this plugin"));
                }

                result.Add(group);

                return result;
            }

            return null;
        }
    }
}
